package jrummikub.util;

/**
 * Interface for classes that can receive parameterless events having a two
 * parameters
 * 
 * @param <T1>
 *            type of the first event parameter
 * @param <T2>
 *            type of the second event parameter
 * @param <T3>
 *            type of third event parameter
 */
public interface IListener3<T1, T2, T3> {
	/**
	 * This method is called whenever a class we're listening to emits an event
	 * 
	 * @param value1
	 *            the first event parameter
	 * @param value2
	 *            the second event parameter
	 * @param value3
	 *            the third event parameter
	 */
	public void handle(T1 value1, T2 value2, T3 value3);
}
